<template>
  <div class="app-container">
    <div style="width: 100%">
      <el-card class="box-card" >
        <div slot="header" style="text-align: center">
          <span style="font-weight: bold; font-size: 30px; text-align: center">曲轴配瓦</span>
        </div>
      </el-card>
      <el-col :span="14" >
        <el-card class="bottom-card">
          <div slot="header" class="clearfix">
            <i class="el-icon-tickets"></i>
            <span style="font-weight: bold">当前产品信息</span>
          </div>
          <el-descriptions :column="1"  :label-style="{'font-size': '20px'}" border  :content-style="{'min-width': '300px'}">
            <el-descriptions-item label="机型">
              <span>{{queryParams.productSeries}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="箱体码">
              <span>{{queryParams.scanObject1}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="曲轴码">
              <span>{{queryParams.scanObject2}}</span>
            </el-descriptions-item>
            <!--            <el-descriptions-item label="轴名称">-->
            <!--              <span>{{queryParams.axisName}}</span>-->
            <!--            </el-descriptions-item>-->
            <!--            <el-descriptions-item label="颈名称">-->
            <!--              <span>{{queryParams.neckName}}</span>-->
            <!--            </el-descriptions-item>-->
            <el-descriptions-item label="瓦名称">
              <span>{{queryParams.tileName}}</span>
            </el-descriptions-item>
            <!--            <el-descriptions-item label="重量">-->
            <!--              <span>{{queryParams.weight}}</span>-->
            <!--            </el-descriptions-item>-->
            <el-descriptions-item label="配瓦颜色">
              <span v-for="(word, index) in queryParams.words" :key="index" :style="{ backgroundColor: queryParams.colors[index],fontSize: '30px',}">{{ word }}</span>
            </el-descriptions-item>
          </el-descriptions>
          <el-divider></el-divider>
        </el-card>
      </el-col>
      <el-col :span="10" >
        <div id="block"  >
          <!-- 变量赋值 :src="imageUrl"  -->
          <!-- 直接读取文件路径 :src="require('@/assets/images/profile.jpg')" -->
          <el-image id="imageRef" fit="contain" :src="require('@/assets/images/463XT.png')" style="width:480px;height:390px;"
                    @click="clickMarkPoint($event)"></el-image>
          <div1 class="marker" id="marker5" style="width: 20px; height: 20px; backgroundColor: red; right: 88px; bottom: 132px; position: relative; border-radius: 50%;"
          >
            <span><font style="color:yellow;text-align:center">5</font></span>
          </div1>
          <div2 class="marker" id="marker4" style="width: 20px; height: 20px; background-color: red; right: 173px; bottom: 132px; position: relative; border-radius: 50%;">
            <span><font style="color:yellow;text-align:center">4</font></span>
          </div2>
          <div3 class="marker" id="marker3" style="width: 20px; height: 20px; background-color: red; right: 260px; bottom: 132px; position: relative; border-radius: 50%;">
            <span><font style="color:yellow;text-align:center">3</font></span>
          </div3>
          <div4 class="marker" id="marker2" style="width: 20px; height: 20px; background-color: red; right: 345px; bottom: 132px; position: relative; border-radius: 50%;">
            <span><font style="color:yellow;text-align:center">2</font></span>
          </div4>
          <div5 class="marker" id="marker1" style="width: 20px; height: 20px; background-color: red; right: 435px; bottom: 132px; position: relative; border-radius: 50%;">
            <span><font style="color:yellow;text-align:center">1</font></span>
          </div5>
        </div>

      </el-col>
    </div>
  </div>
</template>
<script>
import VueQr from 'vue-qr'
import { listTileMatchRules,getTileMatchRules, delTileMatchRules, addTileMatchRules, updateTileMatchRules } from "@/api/main/bs/tileMatchRules/tileMatchRules";
import {forceUploadMethod, getUrl} from "@/api/main/bs/orderScheduling/orderScheduling";
import WebSocketReconnect from "@/utils/WebsocketTool";
import {getCheckData} from "../../../../api/main/bs/tileMatchRules/tileMatchRules";
export default {
  name: "index",
  dicts: ['colour_hex','productseries','axisname','neckname','tilename'],
  components: {
    VueQr,
  },
  data(){
    return{
      loading: true,
      tileMatchKbList: [],
      qrCode: '',
      result: {},
      websocketUrl: '',
      // 查询参数
      from:{
        pageNum: 1,
        pageSize: 10,
        productSeries: '',
        scanObject1: '',
        scanObject2: '',
        SNCode: '',
        // scanObject1: null,
        // scanObject2: null,
        axisName: null,
        neckName: null,
        tileName: '主轴瓦',
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        tileColor: null,
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productSeries: null,
        scanObject1: null,
        scanObject2: null,
        axisName: null,
        neckName: null,
        tileName: null,
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        tileColor: null,
        words: ['------', '------', '------', '------'],
        colors: ['#FFFFFF', '#FFFFFF', '#FFFFFF', '#FFFFFF'],
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
    }
  },
  mounted() {
    this.getWebUrl()
  },
  methods: {
    getWebUrl() {
      getUrl().then(res => {
        this.websocketUrl = res + "OP060"
        console.log('websocketUrl：', this.websocketUrl)
        this.initWebSocket()
      })
    },
    initWebSocket: function () {
      //判断当前浏览器是否支持WebSocket
      if ('WebSocket' in window) {
        //连接WebSocket节点
        this.websocket = new WebSocketReconnect(this.websocketUrl);
        //接收到消息的回调方法
        this.websocket.socket.onmessage = (event) => {
          let data = event.data;
          if (data != null && data !== '') {
            this.result = JSON.parse(data);
            const parts3 = this.result.server_message.split("*");
            if (parts3.length >= 2) {
              if (parts3[0] === 'clean'){
                this.from.scanObject1 = ''
                this.from.scanObject2 = ''
                this.from.SNCode = ''
                this.queryParams.scanObject1 = ''
                this.queryParams.scanObject2 = ''
                this.queryParams.SNCode = ''
                this.queryParams.productSeries = ''
                this.from.productSeries = ''
                this.queryParams.words = ['------', '------', '------', '------']
                this.queryParams.colors = ['#FFFFFF', '#FFFFFF', '#FFFFFF', '#FFFFFF']
              } else {
                this.from.scanObject1 = parts3[0];
                this.from.scanObject2 = parts3[1];
                this.from.SNCode = parts3[2];
                this.handleQuery();
              }

            }
            // if (this.form.scanObject1 !== null && this.form.scanObject1 !== ''){
            //    this.handleQuery();
            // }
          }
        }
        //监听窗口关闭事件，当窗口关闭时，主动去关闭websocket连接，防止连接还没断开就关闭窗口，server端会抛异常。
        window.onbeforeunload = function () {
          this.websocket.close()
        }

        //关闭连接
        function closeWebSocket() {
          this.websocket.close()
        }

        //发送消息
        function send() {
          this.websocket.socket.send({kk: 123})
        }
      } else {
        alert('浏览器不支持webSocket')
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      console.log('111111111')
      this.clear();

      if (this.from.scanObject1 !== null && this.from.scanObject1 !== ""
        // && this.from.axisName !== null && this.from.axisName !== ""
        // && this.from.neckName !== null && this.from.neckName !== ""
        // && this.from.tileName !== null && this.from.tileName !== ""
        && this.from.scanObject2 !== null && this.from.scanObject2 !== "") {
        console.log('2222222')
        this.axisValueextracted();
        this.neckValueextracted();
        if (this.queryParams.axisValue !== null && this.queryParams.neckValue !== null) {
          this.insetFromToQueryParams();
          this.getList();
        } else {
          const h = this.$createElement;
          this.$message({
            message: h('p', null, [
              h('span', null, '警告 '),
              h('i', {style: 'color: black'}, '箱体码或曲轴码输入有误'),
              h()]),
            type: 'error',
            center: true,
            offset: 300
          });
        }
      } else {
        const h = this.$createElement;
        this.$message({
          message: h('p', null, [
            h('span', null, '警告 '),
            h('i', {style: 'color: black'}, '请填写所有搜索条件'),
            h()]),
          type: 'error',
          center: true,
          offset: 300
        });
      }
    },

    // 取箱体码第三段为配瓦值
    axisValueextracted() {
      console.log("33")
      if (this.from.scanObject1.indexOf(";") !== -1) {
        const parts1 = this.from.scanObject1.split(";");
        if (parts1.length >= 3) {
          console.log("44", parts1)
          //const axisValueextracted = parts1[2].substring(3,4);
          const axisValueextracted = parts1[2];
          return this.queryParams.axisValue = axisValueextracted;

        }
      }
    },

    //取曲轴码第三段为配瓦值
    neckValueextracted() {
      console.log('4432')
      console.log('scanObject2', this.from.scanObject2)
      if (this.from.scanObject2.indexOf(";") !== -1) {
        const parts2 = this.from.scanObject2.split(";");
        if (parts2.length >= 3) {
          //const neckValueextracted = parts2[2].substring(3,4);
          const neckValueextracted = parts2[2];
          return this.queryParams.neckValue = neckValueextracted;
        }
      }
    },
    //取配瓦颜色
    getList() {
      let queryParams = {
        SNCode: this.from.SNCode,
        XT: this.from.scanObject1,
        CZ: this.from.scanObject2,
      }
      console.log('queryParams', queryParams)
      getCheckData(queryParams).then(response => {
        console.log('resssss', response)
        this.queryParams.words = ['------', '------', '------', '------']
        this.queryParams.colors = ['#FFFFFF', '#FFFFFF', '#FFFFFF', '#FFFFFF']
        if (response.code === 200) {
          if (response.data.length > 0) {
            this.queryParams.productSeries = response.data[0].productSeries
          }
          for (var i = 0; i < response.data.length; i++) {
            this.queryParams.colors[i] = response.data[i].tileColor;
            this.queryParams.words[i] = response.data[i].tileName;
          }

          document.getElementById('marker1').style.backgroundColor = this.queryParams.colors[0];
          document.getElementById('marker2').style.backgroundColor = this.queryParams.colors[1];
          document.getElementById('marker3').style.backgroundColor = this.queryParams.colors[2];
          document.getElementById('marker4').style.backgroundColor = this.queryParams.colors[3];
          document.getElementById('marker5').style.backgroundColor = this.queryParams.colors[4];
          console.log('颜色：', response)
        }

      });
    },
    clear() {
      this.queryParams.axisValue = null;
      this.queryParams.neckValue = null;
    },
    insetFromToQueryParams() {
      this.queryParams.productSeries = this.from.productSeries;
      this.queryParams.axisName = this.from.axisName;
      this.queryParams.neckName = this.from.neckName;
      this.queryParams.tileName = this.from.tileName;
      this.queryParams.scanObject1 = this.from.scanObject1;
      this.queryParams.scanObject2 = this.from.scanObject2;
    }

  },
}
</script>

<style scoped>
::v-deep .el-form-item__label {
  font-size: large;
}

::v-deep .el-card__body {
  padding: 15px 20px 0px 20px;
}

::v-deep .el-input .el-input--medium .el-input--suffix {
  width: 200px;
}

</style>
